# ![Ipytone](docs/_static/ipytone_logo_dark.svg)

*Interactive audio in Jupyter*

[![JupyterLite](https://jupyterlite.rtfd.io/en/latest/_static/badge-launch.svg)](https://ipytone.readthedocs.io/en/latest/lite/retro/notebooks/?path=quick_demo.ipynb)
[![Tests](https://github.com/benbovy/ipytone/workflows/Test/badge.svg)](https://github.com/benbovy/ipytone/actions)

Ipytone exposes many features of the [Tone.js](https://tonejs.github.io) library
to Python as [Jupyter widgets](https://ipywidgets.readthedocs.io). It allows
turning Jupyter into a versatile DAW (Digital Audio Workstation) for music
creation, sound design, data sonification, and more...

...like this little piece of music entirely composed and played in a Jupyter notebook,
with a custom Earth Globe VU-meter!

https://user-images.githubusercontent.com/4160723/172623510-3423505f-cd27-4770-8553-b2f0dc75384f.mov

## Try Ipytone!

Click [here](https://ipytone.readthedocs.io/en/latest/lite/retro/notebooks/?path=quick_demo.ipynb) or
on the JupyterLite badge above to try ipytone in your browser without installing anything.

For more advanced examples, check this repository: https://github.com/benbovy/ipytone-examples

## Documentation

https://ipytone.readthedocs.io

## Requirements

* JupyterLab >= 3.0 or Jupyter notebook.
* numpy

## Install

You can install ipytone either with [pip](#with-pip) or [conda](#with-conda).

### With pip

```sh
pip install ipytone
```

### With conda

```sh
conda install -c conda-forge ipytone
```

or mamba


```sh
mamba install -c conda-forge ipytone
```

### From source

For a development installation of ipytone, check the installation section in the documentation.
