import { IWidgetManager, WidgetModel } from '@jupyter-widgets/base';
interface ReceivedSerializedArray {
    shape: number[];
    dtype: string;
    buffer: DataView | DataView[];
}
type SerializedDataArray = null | string | ReceivedSerializedArray;
type DeserializedDataArray = null | Promise<any> | WidgetModel | Float32Array | Float32Array[];
export type ArrayProperty = null | Float32Array | Float32Array[];
export declare function getArrayProp(obj: DeserializedDataArray): ArrayProperty;
declare function deserializeDataArray(value: SerializedDataArray, manager?: IWidgetManager): DeserializedDataArray;
declare function serializeDataArray(obj: DeserializedDataArray, _widget?: WidgetModel): any;
export declare const dataarray_serialization: {
    deserialize: typeof deserializeDataArray;
    serialize: typeof serializeDataArray;
};
export {};
