import * as tone from 'tone';
import { AudioNodeModel } from './widget_base';
import { ObservableModel } from './widget_observe';
export declare class AnalyserModel extends AudioNodeModel implements ObservableModel {
    defaults(): any;
    createNode(): tone.Analyser;
    getValueAtTime(traitName: string, _time: tone.Unit.Seconds): Float32Array | Float32Array[];
    getValue(traitName: string): Float32Array | Float32Array[];
    initEventListeners(): void;
    node: tone.Analyser;
    static model_name: string;
}
declare abstract class BaseMeterModel extends AudioNodeModel implements ObservableModel {
    getValueAtTime(traitName: string, _time: tone.Unit.Seconds): Float32Array | Float32Array[] | number | number[];
    getValue(traitName: string): Float32Array | Float32Array[] | number | number[];
    node: tone.Meter | tone.DCMeter | tone.Waveform | tone.FFT;
}
export declare class MeterModel extends BaseMeterModel {
    defaults(): any;
    createNode(): tone.Meter;
    initEventListeners(): void;
    node: tone.Meter;
    static model_name: string;
}
export declare class DCMeterModel extends BaseMeterModel {
    defaults(): any;
    createNode(): tone.DCMeter;
    node: tone.DCMeter;
    static model_name: string;
}
export declare class WaveformModel extends BaseMeterModel {
    defaults(): any;
    createNode(): tone.Waveform;
    initEventListeners(): void;
    node: tone.Waveform;
    static model_name: string;
}
export declare class FFTModel extends BaseMeterModel {
    defaults(): any;
    createNode(): tone.FFT;
    initEventListeners(): void;
    node: tone.FFT;
    static model_name: string;
}
export {};
