"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PyInternalAudioNodeModel = exports.PyToneAudioNode = exports.AudioNodeModel = exports.NodeWithContextModel = exports.ToneObjectModel = exports.NativeAudioParamModel = exports.NativeAudioNodeModel = exports.ToneWidgetModel = void 0;
const base_1 = require("@jupyter-widgets/base");
const tone = __importStar(require("tone"));
// import * as tone_base from 'tone/Tone/core/Tone';
const version_1 = require("./version");
class ToneWidgetModel extends base_1.WidgetModel {
    defaults() {
        return Object.assign(Object.assign({}, super.defaults()), { _model_module: ToneWidgetModel.model_module, _model_module_version: ToneWidgetModel.model_module_version });
    }
    initialize(attributes, options) {
        super.initialize(attributes, options);
        this.initEventListeners();
    }
    initEventListeners() {
        /**/
    }
}
exports.ToneWidgetModel = ToneWidgetModel;
ToneWidgetModel.model_module = version_1.MODULE_NAME;
ToneWidgetModel.model_module_version = version_1.MODULE_VERSION;
class NativeAudioNodeModel extends ToneWidgetModel {
    defaults() {
        return Object.assign(Object.assign({}, super.defaults()), { _model_name: NativeAudioNodeModel.model_name, _n_inputs: 1, _n_outputs: 1, type: '' });
    }
    connectInputCallback() {
        /**/
    }
    setNode(node) {
        this.node = node;
    }
}
exports.NativeAudioNodeModel = NativeAudioNodeModel;
NativeAudioNodeModel.model_name = 'NativeAudioNodeModel';
class NativeAudioParamModel extends ToneWidgetModel {
    defaults() {
        return Object.assign(Object.assign({}, super.defaults()), { _model_name: NativeAudioParamModel.model_name, type: '' });
    }
    connectInputCallback() {
        /**/
    }
    setNode(node) {
        this.node = node;
    }
}
exports.NativeAudioParamModel = NativeAudioParamModel;
NativeAudioParamModel.model_name = 'NativeAudioParamModel';
class ToneObjectModel extends ToneWidgetModel {
    defaults() {
        return Object.assign(Object.assign({}, super.defaults()), { _model_name: ToneObjectModel.model_name, _disposed: false });
    }
    setNode(node) {
        this.node = node;
    }
    get disposed() {
        return this.get('_disposed');
    }
    dispose() {
        // Tone.js calls dispose internally for sub-nodes such as input, output, etc.
        // so we need to check if the node is already disposed
        if (!this.node.disposed) {
            this.node.dispose();
        }
    }
    initEventListeners() {
        super.initEventListeners();
        this.on('change:_disposed', this.dispose, this);
    }
}
exports.ToneObjectModel = ToneObjectModel;
ToneObjectModel.model_name = 'ToneObjectModel';
class NodeWithContextModel extends ToneObjectModel {
    defaults() {
        return Object.assign(Object.assign({}, super.defaults()), { _model_name: NodeWithContextModel.model_name, name: '' });
    }
}
exports.NodeWithContextModel = NodeWithContextModel;
NodeWithContextModel.model_name = 'NodeWithContextModel';
class AudioNodeModel extends NodeWithContextModel {
    defaults() {
        return Object.assign(Object.assign({}, super.defaults()), { _model_name: AudioNodeModel.model_name, _create_node: true, _input: null, _output: null, _set_node_channels: true, channel_count: 2, channel_count_mode: 'max', channel_interpretation: 'speakers' });
    }
    initialize(attributes, options) {
        super.initialize(attributes, options);
        if (this.get('_create_node')) {
            this.node = this.createNode();
            if (this.get('_set_node_channels')) {
                this.setNodeChannels();
            }
            this.setInputOutputNodes();
            this.setSubNodes();
        }
    }
    get input() {
        return this.get('_input');
    }
    get output() {
        return this.get('_output');
    }
    connectInputCallback() {
        /**/
    }
    setNode(node) {
        this.node = node;
        if (this.get('_set_node_channels')) {
            this.setNodeChannels();
        }
        this.setInputOutputNodes();
        this.setSubNodes();
    }
    setNodeChannels() {
        this.node.channelCount = this.get('channel_count');
        this.node.channelCountMode = this.get('channel_count_mode');
        this.node.channelInterpretation = this.get('channel_interpretation');
    }
    setInputOutputNodes() {
        if (this.input !== null) {
            this.input.setNode(this.node.input);
        }
        if (this.output !== null) {
            this.output.setNode(this.node.output);
        }
    }
    setSubNodes() {
        /**/
    }
    initEventListeners() {
        super.initEventListeners();
        this.on('change:channel_count', this.setNodeChannels, this);
        this.on('change:channel_count_mode', this.setNodeChannels, this);
        this.on('change:channel_interpretation', this.setNodeChannels, this);
    }
}
exports.AudioNodeModel = AudioNodeModel;
AudioNodeModel.serializers = Object.assign(Object.assign({}, ToneWidgetModel.serializers), { _input: { deserialize: base_1.unpack_models }, _output: { deserialize: base_1.unpack_models } });
AudioNodeModel.model_name = 'AudioNodeModel';
/**
 * A basic Tone.js audio node that just accepts any input/output.
 * It is meant to be wrapped by a PyInternalAudioNode widget.
 */
class PyToneAudioNode extends tone.ToneAudioNode {
    constructor(input, output) {
        super();
        this.name = 'PyToneAudioNode';
        this.input = input;
        this.output = output;
    }
}
exports.PyToneAudioNode = PyToneAudioNode;
class PyInternalAudioNodeModel extends AudioNodeModel {
    defaults() {
        return Object.assign(Object.assign({}, super.defaults()), { _model_name: PyInternalAudioNodeModel.model_name });
    }
    createNode() {
        const input_node = this.input === null ? undefined : this.input.node;
        const output_node = this.output === null ? undefined : this.output.node;
        return new PyToneAudioNode(input_node, output_node);
    }
}
exports.PyInternalAudioNodeModel = PyInternalAudioNodeModel;
PyInternalAudioNodeModel.model_name = 'PyInternalAudioNodeModel';
//# sourceMappingURL=widget_base.js.map