/// <reference types="backbone" />
import { ISerializers } from '@jupyter-widgets/base';
import * as tone from 'tone';
import { AudioNodeModel } from './widget_base';
import { GainModel, ParamModel } from './widget_core';
import { SignalModel } from './widget_signal';
export declare class CrossFadeModel extends AudioNodeModel {
    defaults(): any;
    createNode(): tone.CrossFade;
    setSubNodes(): void;
    get a(): GainModel;
    get b(): GainModel;
    get fade(): SignalModel<'normalRange'>;
    static serializers: ISerializers;
    node: tone.CrossFade;
    static model_name: string;
}
export declare class PannerModel extends AudioNodeModel {
    defaults(): any;
    createNode(): tone.Panner;
    setSubNodes(): void;
    get pan(): ParamModel<'audioRange'>;
    static serializers: ISerializers;
    node: tone.Panner;
    static model_name: string;
}
export declare class Panner3DModel extends AudioNodeModel {
    defaults(): any;
    createNode(): tone.Panner3D;
    setSubNodes(): void;
    static serializers: ISerializers;
    initEventListeners(): void;
    node: tone.Panner3D;
    static model_name: string;
}
export declare class SoloModel extends AudioNodeModel {
    defaults(): any;
    initialize(attributes: Backbone.ObjectHash, options: {
        model_id: string;
        comm: any;
        widget_manager: any;
    }): void;
    createNode(): tone.Solo;
    get solo(): boolean;
    set solo(solo: boolean);
    initEventListeners(): void;
    node: tone.Solo;
    private static _allSoloModels;
    static model_name: string;
}
export declare class MergeModel extends AudioNodeModel {
    defaults(): any;
    createNode(): tone.Merge;
    node: tone.Merge;
    static model_name: string;
}
export declare class SplitModel extends AudioNodeModel {
    defaults(): any;
    createNode(): tone.Split;
    node: tone.Split;
    static model_name: string;
}
