"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CompressorModel = void 0;
const base_1 = require("@jupyter-widgets/base");
const tone = __importStar(require("tone"));
const widget_base_1 = require("./widget_base");
class CompressorModel extends widget_base_1.AudioNodeModel {
    defaults() {
        return Object.assign(Object.assign({}, super.defaults()), { _model_name: CompressorModel.model_name, _threshold: undefined, _ratio: undefined, _attack: undefined, _release: undefined, _knee: undefined });
    }
    createNode() {
        return new tone.Compressor({
            threshold: this.threshold.value,
            ratio: this.ratio.value,
            attack: this.attack.value,
            release: this.release.value,
            knee: this.knee.value,
        });
    }
    setSubNodes() {
        super.setSubNodes();
        this.threshold.setNode(this.node.threshold);
        this.ratio.setNode(this.node.ratio);
        this.attack.setNode(this.node.attack);
        this.release.setNode(this.node.release);
        this.knee.setNode(this.node.knee);
    }
    get threshold() {
        return this.get('_threshold');
    }
    get ratio() {
        return this.get('_ratio');
    }
    get attack() {
        return this.get('_attack');
    }
    get release() {
        return this.get('_release');
    }
    get knee() {
        return this.get('_knee');
    }
}
exports.CompressorModel = CompressorModel;
CompressorModel.serializers = Object.assign(Object.assign({}, widget_base_1.AudioNodeModel.serializers), { _threshold: { deserialize: base_1.unpack_models }, _ratio: { deserialize: base_1.unpack_models }, _attack: { deserialize: base_1.unpack_models }, _release: { deserialize: base_1.unpack_models }, _knee: { deserialize: base_1.unpack_models } });
CompressorModel.model_name = 'CompressorModel';
//# sourceMappingURL=widget_dynamics.js.map