/// <reference types="backbone" />
import { ISerializers } from '@jupyter-widgets/base';
import * as tone from 'tone';
import { AudioNodeModel } from './widget_base';
import { ObservableModel } from './widget_observe';
import { ArrayProperty } from './serializers';
export declare class EnvelopeModel extends AudioNodeModel implements ObservableModel {
    defaults(): any;
    initialize(attributes: Backbone.ObjectHash, options: {
        model_id: string;
        comm: any;
        widget_manager: any;
    }): void;
    get array(): ArrayProperty;
    set array(value: ArrayProperty);
    createNode(): tone.Envelope;
    setNode(node: tone.Envelope): void;
    maybeSetArray(): void;
    updateEnvelope(trait_name: string, node_property: string): void;
    getValueAtTime(traitName: string, time: tone.Unit.Seconds): tone.Unit.NormalRange;
    getValue(traitName: string): tone.Unit.NormalRange;
    private handleMsg;
    initEventListeners(): void;
    node: tone.Envelope;
    static serializers: ISerializers;
    static model_name: string;
}
export declare class AmplitudeEnvelopeModel extends EnvelopeModel {
    defaults(): any;
    createNode(): tone.AmplitudeEnvelope;
    node: tone.AmplitudeEnvelope;
    static model_name: string;
}
export declare class FrequencyEnvelopeModel extends EnvelopeModel {
    defaults(): any;
    createNode(): tone.FrequencyEnvelope;
    initEventListeners(): void;
    node: tone.FrequencyEnvelope;
    static model_name: string;
}
