/// <reference types="backbone" />
import { ISerializers } from '@jupyter-widgets/base';
import * as tone from 'tone';
import { AudioNodeModel } from './widget_base';
import { ParamModel } from './widget_core';
import { SignalModel } from './widget_signal';
import { ArrayProperty } from './serializers';
export declare class BiquadFilterModel extends AudioNodeModel {
    defaults(): any;
    initialize(attributes: Backbone.ObjectHash, options: {
        model_id: string;
        comm: any;
        widget_manager: any;
    }): void;
    createNode(): tone.BiquadFilter;
    setSubNodes(): void;
    maybeSetArray(): void;
    get frequency(): ParamModel<'frequency'>;
    get q(): ParamModel<'number'>;
    get detune(): ParamModel<'cents'>;
    get gain(): ParamModel<'decibels'>;
    get array(): ArrayProperty;
    set array(value: ArrayProperty);
    initEventListeners(): void;
    static serializers: ISerializers;
    node: tone.BiquadFilter;
    static model_name: string;
}
export declare class FilterModel extends AudioNodeModel {
    defaults(): any;
    initialize(attributes: Backbone.ObjectHash, options: {
        model_id: string;
        comm: any;
        widget_manager: any;
    }): void;
    createNode(): tone.Filter;
    setSubNodes(): void;
    maybeSetArray(): void;
    get frequency(): SignalModel<'frequency'>;
    get q(): SignalModel<'positive'>;
    get detune(): SignalModel<'cents'>;
    get gain(): SignalModel<'decibels'>;
    get array(): ArrayProperty;
    set array(value: ArrayProperty);
    initEventListeners(): void;
    static serializers: ISerializers;
    node: tone.Filter;
    static model_name: string;
}
export declare class OnePoleFilterModel extends AudioNodeModel {
    defaults(): any;
    initialize(attributes: Backbone.ObjectHash, options: {
        model_id: string;
        comm: any;
        widget_manager: any;
    }): void;
    createNode(): tone.OnePoleFilter;
    maybeSetArray(): void;
    get array(): ArrayProperty;
    set array(value: ArrayProperty);
    initEventListeners(): void;
    static serializers: ISerializers;
    node: tone.OnePoleFilter;
    static model_name: string;
}
export declare class FeedbackCombFilterModel extends AudioNodeModel {
    defaults(): any;
    createNode(): tone.FeedbackCombFilter;
    setSubNodes(): void;
    get delayTime(): ParamModel<'time'>;
    get resonance(): ParamModel<'normalRange'>;
    static serializers: ISerializers;
    node: tone.FeedbackCombFilter;
    static model_name: string;
}
