"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FeedbackCombFilterModel = exports.OnePoleFilterModel = exports.FilterModel = exports.BiquadFilterModel = void 0;
const base_1 = require("@jupyter-widgets/base");
const tone = __importStar(require("tone"));
// import { PhaseShiftAllpass } from 'tone/Tone/component/filter/PhaseShiftAllpass';
const widget_base_1 = require("./widget_base");
const serializers_1 = require("./serializers");
class BiquadFilterModel extends widget_base_1.AudioNodeModel {
    defaults() {
        return Object.assign(Object.assign({}, super.defaults()), { _model_name: BiquadFilterModel.model_name, type: 'lowpass', _frequency: undefined, _q: undefined, _detune: undefined, _gain: undefined, array: null, array_length: 128, sync_array: false });
    }
    initialize(attributes, options) {
        super.initialize(attributes, options);
        if (this.get('_create_node')) {
            this.maybeSetArray();
        }
    }
    createNode() {
        return new tone.BiquadFilter({
            type: this.get('type'),
            frequency: this.frequency.value,
            Q: this.q.value,
            detune: this.detune.value,
            gain: this.gain.value,
        });
    }
    setSubNodes() {
        super.setSubNodes();
        this.frequency.setNode(this.node.frequency);
        this.q.setNode(this.node.Q);
        this.detune.setNode(this.node.detune);
        this.gain.setNode(this.node.gain);
    }
    maybeSetArray() {
        if (this.get('sync_array')) {
            this.array = this.node.getFrequencyResponse(this.get('array_length'));
            this.save_changes();
        }
    }
    get frequency() {
        return this.get('_frequency');
    }
    get q() {
        return this.get('_q');
    }
    get detune() {
        return this.get('_detune');
    }
    get gain() {
        return this.get('_gain');
    }
    get array() {
        return (0, serializers_1.getArrayProp)(this.get('array'));
    }
    set array(value) {
        // avoid infinite event listener loop
        this.set('array', value, { silent: true });
    }
    initEventListeners() {
        super.initEventListeners();
        this.on('change:type', () => {
            this.node.type = this.get('type');
            this.maybeSetArray();
        });
        this.frequency.on('change:value', () => this.maybeSetArray());
        this.q.on('change:value', () => this.maybeSetArray());
        this.detune.on('change:value', () => this.maybeSetArray());
        this.gain.on('change:value', () => this.maybeSetArray());
    }
}
exports.BiquadFilterModel = BiquadFilterModel;
BiquadFilterModel.serializers = Object.assign(Object.assign({}, widget_base_1.AudioNodeModel.serializers), { _frequency: { deserialize: base_1.unpack_models }, _q: { deserialize: base_1.unpack_models }, _detune: { deserialize: base_1.unpack_models }, _gain: { deserialize: base_1.unpack_models }, array: serializers_1.dataarray_serialization });
BiquadFilterModel.model_name = 'BiquadFilterModel';
class FilterModel extends widget_base_1.AudioNodeModel {
    defaults() {
        return Object.assign(Object.assign({}, super.defaults()), { _model_name: FilterModel.model_name, type: 'lowpass', _frequency: undefined, _q: undefined, _detune: undefined, _gain: undefined, rolloff: -12, array: null, array_length: 128, sync_array: false });
    }
    initialize(attributes, options) {
        super.initialize(attributes, options);
        if (this.get('_create_node')) {
            this.maybeSetArray();
        }
    }
    createNode() {
        return new tone.Filter({
            type: this.get('type'),
            frequency: this.frequency.value,
            Q: this.q.value,
            detune: this.detune.value,
            gain: this.gain.value,
            rolloff: this.get('rolloff'),
        });
    }
    setSubNodes() {
        super.setSubNodes();
        this.frequency.setNode(this.node.frequency);
        this.q.setNode(this.node.Q);
        this.detune.setNode(this.node.detune);
        this.gain.setNode(this.node.gain);
    }
    maybeSetArray() {
        if (this.get('sync_array')) {
            this.array = this.node.getFrequencyResponse(this.get('array_length'));
            this.save_changes();
        }
    }
    get frequency() {
        return this.get('_frequency');
    }
    get q() {
        return this.get('_q');
    }
    get detune() {
        return this.get('_detune');
    }
    get gain() {
        return this.get('_gain');
    }
    get array() {
        return (0, serializers_1.getArrayProp)(this.get('array'));
    }
    set array(value) {
        // avoid infinite event listener loop
        this.set('array', value, { silent: true });
    }
    initEventListeners() {
        super.initEventListeners();
        this.on('change:type', () => {
            this.node.type = this.get('type');
            this.maybeSetArray();
        });
        this.frequency.on('change:value', () => this.maybeSetArray());
        this.q.on('change:value', () => this.maybeSetArray());
        this.detune.on('change:value', () => this.maybeSetArray());
        this.gain.on('change:value', () => this.maybeSetArray());
        this.on('change:rolloff', () => {
            this.node.rolloff = this.get('rolloff');
            this.maybeSetArray();
        });
    }
}
exports.FilterModel = FilterModel;
FilterModel.serializers = Object.assign(Object.assign({}, widget_base_1.AudioNodeModel.serializers), { _frequency: { deserialize: base_1.unpack_models }, _q: { deserialize: base_1.unpack_models }, _detune: { deserialize: base_1.unpack_models }, _gain: { deserialize: base_1.unpack_models }, array: serializers_1.dataarray_serialization });
FilterModel.model_name = 'FilterModel';
class OnePoleFilterModel extends widget_base_1.AudioNodeModel {
    defaults() {
        return Object.assign(Object.assign({}, super.defaults()), { _model_name: OnePoleFilterModel.model_name, type: 'lowpass', frequency: 880, array: null, array_length: 128, sync_array: false });
    }
    initialize(attributes, options) {
        super.initialize(attributes, options);
        if (this.get('_create_node')) {
            this.maybeSetArray();
        }
    }
    createNode() {
        return new tone.OnePoleFilter({
            type: this.get('type'),
            frequency: this.get('frequency'),
        });
    }
    maybeSetArray() {
        if (this.get('sync_array')) {
            this.array = this.node.getFrequencyResponse(this.get('array_length'));
            this.save_changes();
        }
    }
    get array() {
        return (0, serializers_1.getArrayProp)(this.get('array'));
    }
    set array(value) {
        // avoid infinite event listener loop
        this.set('array', value, { silent: true });
    }
    initEventListeners() {
        super.initEventListeners();
        this.on('change:type', () => {
            this.node.type = this.get('type');
            this.maybeSetArray();
        });
        this.on('change:frequency', () => {
            this.node.frequency = this.get('frequency');
            this.maybeSetArray();
        });
    }
}
exports.OnePoleFilterModel = OnePoleFilterModel;
OnePoleFilterModel.serializers = Object.assign(Object.assign({}, widget_base_1.AudioNodeModel.serializers), { array: serializers_1.dataarray_serialization });
OnePoleFilterModel.model_name = 'OnePoleFilterModel';
class FeedbackCombFilterModel extends widget_base_1.AudioNodeModel {
    defaults() {
        return Object.assign(Object.assign({}, super.defaults()), { _model_name: FeedbackCombFilterModel.model_name, _delay_time: undefined, _resonance: undefined });
    }
    createNode() {
        return new tone.FeedbackCombFilter({
            delayTime: this.delayTime.value,
            resonance: this.resonance.value,
        });
    }
    setSubNodes() {
        super.setSubNodes();
        this.delayTime.setNode(this.node.delayTime);
        this.resonance.setNode(this.node.resonance);
    }
    get delayTime() {
        return this.get('_delay_time');
    }
    get resonance() {
        return this.get('_resonance');
    }
}
exports.FeedbackCombFilterModel = FeedbackCombFilterModel;
FeedbackCombFilterModel.serializers = Object.assign(Object.assign({}, widget_base_1.AudioNodeModel.serializers), { _delay_time: { deserialize: base_1.unpack_models }, _resonance: { deserialize: base_1.unpack_models } });
FeedbackCombFilterModel.model_name = 'FeedbackCombFilterModel';
// TODO: Tone.js PhaseShiftAllpass not (yet?) part of public API
// export class PhaseShiftAllpassModel extends AudioNodeModel {
//   defaults(): any {
//     return {
//       ...super.defaults(),
//       _model_name: PhaseShiftAllpassModel.model_name,
//       _offset90: undefined,
//     };
//   }
//   createNode(): PhaseShiftAllpass {
//     return new PhaseShiftAllpass();
//   }
//   setSubNodes(): void {
//     super.setSubNodes();
//     this.offset90.setNode(this.node.offset90);
//   }
//   get offset90(): GainModel {
//     return this.get('_offset90');
//   }
//   static serializers: ISerializers = {
//     ...AudioNodeModel.serializers,
//     _offset90: { deserialize: unpack_models as any },
//   };
//   node: PhaseShiftAllpass;
//   static model_name = 'PhaseShiftAllpassModel';
// }
//# sourceMappingURL=widget_filter.js.map