/// <reference types="backbone" />
import { ISerializers } from '@jupyter-widgets/base';
import * as tone from 'tone';
import { ToneWidgetModel } from './widget_base';
type TraitValue = tone.Unit.Unit | tone.PlaybackState | Float32Array | Float32Array[] | number | number[];
export interface ObservableModel {
    getValueAtTime: (traitName: string, time: tone.Unit.Seconds) => TraitValue;
    getValue: (traitName: string) => TraitValue;
}
export declare class ScheduleObserverModel extends ToneWidgetModel {
    defaults(): any;
    private event;
    initialize(attributes: Backbone.ObjectHash, options: {
        model_id: string;
        comm: any;
        widget_manager: any;
    }): void;
    get observedWidget(): ObservableModel;
    get observedTrait(): string;
    get observeTime(): boolean;
    private setObservedTrait;
    private scheduleRepeat;
    private scheduleCancel;
    private handleMsg;
    initEventListeners(): void;
    static serializers: ISerializers;
    static model_name: string;
}
export {};
