"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ScheduleObserverModel = void 0;
const base_1 = require("@jupyter-widgets/base");
const tone = __importStar(require("tone"));
const widget_base_1 = require("./widget_base");
const serializers_1 = require("./serializers");
class ScheduleObserverModel extends widget_base_1.ToneWidgetModel {
    defaults() {
        return Object.assign(Object.assign({}, super.defaults()), { _model_name: ScheduleObserverModel.model_name, observed_widget: null, observed_trait: 'value', observe_time: false, time: 0.0, value: 0.0, state: 'stopped', progress: 0.0, position: '0:0:0', ticks: 0, seconds: 0.0, array: [], time_value: [] });
    }
    initialize(attributes, options) {
        super.initialize(attributes, options);
        this.event = { id: 0, transport: false };
    }
    get observedWidget() {
        return this.get('observed_widget');
    }
    get observedTrait() {
        return this.get('observed_trait');
    }
    get observeTime() {
        return this.get('observe_time');
    }
    setObservedTrait(time, transport) {
        const model = this.observedWidget;
        const traitName = this.observedTrait;
        let traitValue = 0;
        if (traitName === 'array') {
            // bug when array elements aren't changing, then it's never
            // synced again even if it gets updated again later?
            // -> reset array value silently
            this.set('array', new Float32Array([0]), { silent: true });
        }
        if (traitName === 'time') {
            traitValue = time;
        }
        else {
            if (transport) {
                traitValue = model.getValueAtTime(traitName, time);
            }
            else {
                traitValue = model.getValue(traitName);
            }
        }
        if (this.observeTime) {
            this.set('time_value', [time, traitValue]);
        }
        else {
            this.set(traitName, traitValue);
        }
        this.save_changes();
    }
    scheduleRepeat(transport, updateInterval, draw) {
        let eid;
        if (transport) {
            eid = tone.Transport.scheduleRepeat((time) => {
                if (draw) {
                    tone.Draw.schedule(() => {
                        this.setObservedTrait(time, transport);
                    }, time);
                }
                else {
                    this.setObservedTrait(time, transport);
                }
            }, updateInterval);
        }
        else {
            eid = setInterval(() => {
                this.setObservedTrait(tone.now(), transport);
            }, updateInterval * 1000);
        }
        this.event = { id: eid, transport: transport };
    }
    scheduleCancel() {
        if (this.event.transport) {
            tone.Transport.cancel(this.event.id);
        }
        else {
            clearInterval(this.event.id);
        }
    }
    handleMsg(command, _buffers) {
        if (command.event === 'scheduleRepeat') {
            this.scheduleRepeat(command.transport, command.update_interval, command.draw);
        }
        else if (command.event === 'scheduleCancel') {
            this.scheduleCancel();
        }
    }
    initEventListeners() {
        this.on('msg:custom', this.handleMsg, this);
    }
}
exports.ScheduleObserverModel = ScheduleObserverModel;
ScheduleObserverModel.serializers = Object.assign(Object.assign({}, widget_base_1.ToneWidgetModel.serializers), { observed_widget: { deserialize: base_1.unpack_models }, array: serializers_1.dataarray_serialization });
ScheduleObserverModel.model_name = 'ScheduleObserverModel';
//# sourceMappingURL=widget_observe.js.map