/// <reference types="backbone" />
import { ISerializers } from '@jupyter-widgets/base';
import * as tone from 'tone';
import { ToneObjectModel } from './widget_base';
import { ParamModel } from './widget_core';
import { ObservableModel } from './widget_observe';
export declare class TransportModel extends ToneObjectModel implements ObservableModel {
    defaults(): any;
    initialize(attributes: Backbone.ObjectHash, options: {
        model_id: string;
        comm: any;
        widget_manager: any;
    }): void;
    get bpm(): ParamModel<'bpm'>;
    protected toSeconds(time: tone.Unit.Time): tone.Unit.Seconds;
    protected toFrequency(frequency: tone.Unit.Frequency): tone.Unit.Hertz;
    private getCallbackItems;
    getValueAtTime(traitName: string, time: tone.Unit.Seconds): tone.Unit.Unit;
    getValue(traitName: string): tone.Unit.Unit;
    private getToneCallback;
    private schedule;
    private syncPosition;
    private syncState;
    private play;
    private clearEvent;
    private syncSignal;
    private handleMsg;
    initEventListeners(): void;
    static serializers: ISerializers;
    py2jsEventID: {
        [id: number]: number;
    };
    static model_name: string;
}
